<template>
	<v-card elevation="20">
		<v-card-title>Datos escolares</v-card-title>
		<v-form>
			<v-card-text>
				<!-- fila para datos de la carrera -->
				<v-row>
					<v-col cols="12" sm="6">
						<v-select
							:disabled="update"
							label="Institución"
							prepend-icon="fas fa-school"
							:items="institutes"
							outlined
							v-model="scholarData.institute"
						/>
					</v-col>
					<v-col cols="12" sm="6">
						<v-select
							:disabled="update"
							label="Carrera"
							prepend-icon="fas fa-school"
							:items="careers"
							no-data-text="Seleccione antes una institución"
							outlined
							v-model="scholarData.career"
						/>
					</v-col>
				</v-row>
				<!-- fila para datos del semestre -->
				<v-row>
					<v-col cols="12" sm="6">
						<v-text-field
							:disabled="update"
							label="Grado escolar actual"
							prepend-icon="fas fa-school"
							:rules="rulesScholarGrade"
							type="number"
							outlined
							v-model="scholarData.semester"
						/>
					</v-col>
					<v-col cols="12" sm="6">
						<v-text-field
							:disabled="update"
							label="Promedio general"
							prepend-icon="fas fa-school"
							type="number"
							:rules="rulesPromedy"
							outlined
							v-model="scholarData.schoolGrade"
						/>
					</v-col>
				</v-row>
			</v-card-text>
			<v-card-actions>
				<v-row justify="center" justify-sm="end">
					<v-col cols="12" sm="3" v-if="update">
						<v-btn block outlined color="orange" @click="update = !update">Modificar</v-btn>
					</v-col>
					<v-col cols="12" sm="3" v-else>
						<v-btn block outlined color="red" @click="cancelUpdate">Cancelar</v-btn>
					</v-col>
					<v-col cols="12" sm="3">
						<v-btn :disabled="update" block outlined :loading="loading" color="green" @click="updateData">
							Actualizar
							<template v-slot:loader>
								<span>Guardando...</span>
							</template>
						</v-btn>
					</v-col>
				</v-row>
			</v-card-actions>
		</v-form>
	</v-card>
</template>

<script>
import gql from "graphql-tag";
import { mapState, mapMutations } from "vuex";

export default {
	name: "ProfileScholarData",
	data: () => ({
		update: true,
		loading: false,
		scholarData: {
			institute: "",
			career: "",
			semester: "",
			schoolGrade: ""
		},
		institutes: [],
		careers: [],
		rulesScholarGrade: [
			value => !!value || "Campo requerido",
			value => (value >= 1 && value <= 15) || "Grado de 1 a 15"
		],
		rulesPromedy: [
			value => !!value || "Campo requerido",
			value => (value >= 0 && value <= 10) || "Solo base de 0 a 10"
		]
	}),
	watch: {
		"scholarData.institute": function(newVal, oldVal) {
			this.careers = [];
			this.getCareers();
		}
	},
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),
		// Obtiene los datos del usuario y llena los inputs
		async getData() {
			this.saveUserData();
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								scholarData {
									institute
									career
									semester
									schoolGrade
								}
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});
				this.scholarData.institute =
					data.findStudent.scholarData.institute;
				this.scholarData.career = data.findStudent.scholarData.career;
				this.scholarData.semester =
					data.findStudent.scholarData.semester;
				this.scholarData.schoolGrade =
					data.findStudent.scholarData.schoolGrade;
				this.getInstitutes();
			} catch (error) {}
		},
		// obtiene las escuelas
		async getInstitutes() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query {
							allInstitutes {
								institute
							}
						}
					`
				});
				for (let i of data.allInstitutes) {
					this.institutes.push(i.institute);
				}
			} catch (error) {}
		},
		// obtiene las carreras
		async getCareers() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($institute: String!) {
							allCareers(institute: $institute) {
								key
							}
						}
					`,
					variables: {
						institute: this.scholarData.institute
					}
				});
				for (let i of data.allCareers) {
					this.careers.push(i.key);
				}
			} catch (error) {}
		},
		// Cancela la modificacion de los inputs
		cancelUpdate() {
			this.getData();
			this.update = !this.update;
		},
		// Actualiza la información
		async updateData() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$institute: String!
							$career: String!
							$semester: String!
							$schoolGrade: String!
						) {
							addUpdateScholarData(
								institute: $institute
								career: $career
								semester: $semester
								schoolGrade: $schoolGrade
							)
						}
					`,
					variables: {
						institute: this.scholarData.institute,
						career: this.scholarData.career,
						semester: this.scholarData.semester,
						schoolGrade: this.scholarData.schoolGrade
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					this.update = true;
				}, 1500);
			} catch (error) {
				console.error(error);
			}
		}
	},
	created() {
		this.getData();
	}
};
</script>